/**************************************************
* File: note.c - application source file
*
*    This file is generated by the program lxb.
*		 (Well, the first original version).
*		
*    Copyright (C) 1995  Bruce Parkin
*
**************************************************/

/* include files */
#include <stdio.h>

#include <Xm/Xm.h>
#include <Xm/MwmUtil.h> 
#include <Xm/BulletinB.h> 
#include <Xm/RowColumn.h> 
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>
#include <Xm/ArrowB.h>
#include <Xm/Separator.h>
#include <Xm/DrawnB.h>
#include <Xm/Frame.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/DrawingA.h>
#include <X11/Shell.h>

#include "note_util.h"
#include "note.h"

/* local variables */
static Widget bb = NULL;
static Widget shell;

/* local prototypes */
static XmString 
make_note();
static void
build_about_gui(Widget parent);

static void
done_callback(Widget w, XtPointer client_data, XtPointer call_data);       

/**********************************************************************
*
* Function: build_about_gui - build the GUI for 
*		a popup dialog that tells about "lxb"
*
*		The advantage to using the XmCreate*Dialog functions
*		over Xt ones is that the Popup Dialog is auto-centered over
*		parent widget.
*
**********************************************************************/
static void
build_about_gui(Widget parent)
{
	Widget drawingArea_1;
	Widget frame_2;
	Widget pushButton_1;
	Widget label_4;
	Arg args[10];
	XmString xmstrings[10];
	XmFontList fontlist;
	int n;

  n=0;
  XtSetArg(args[n], XmNtitle, "About lxb");n++;
  XtSetArg(args[n], XmNdeleteResponse, XmDO_NOTHING);n++;
  XtSetArg(args[n], XmNmwmFunctions,
                    MWM_FUNC_RESIZE|MWM_FUNC_MOVE|MWM_FUNC_MINIMIZE|MWM_FUNC_MAXIMIZE);n++;  

	XtSetArg(args[n], XmNbackground, get_pixel(parent, "gray"));n++;
	bb = XmCreateBulletinBoardDialog(parent, "about_dialog", args, n);

	XtSetArg(args[0], XmNbackground, get_pixel(parent, "gray"));
	drawingArea_1 = XtCreateManagedWidget("drawingArea_1", xmDrawingAreaWidgetClass, bb, args, 1);

	XtSetArg(args[0], XmNshadowThickness, 5);
	XtSetArg(args[1], XmNshadowType, XmSHADOW_OUT);
	frame_2 = XtCreateManagedWidget("frame_2", xmFrameWidgetClass, drawingArea_1, args, 2);

	XtSetArg(args[0], XmNforeground, get_pixel(parent, "black"));
	XtSetArg(args[1], XmNbackground, get_pixel(parent, "gray"));

	fontlist = get_fontlist(parent, "-adobe-helvetica-bold-r-normal--14-140-75-75-p-82-iso8859-1");
	XtSetArg(args[2], XmNfontList, fontlist);

	xmstrings[0] = XmStringCreateSimple("Done");
	XtSetArg(args[3], XmNlabelString, xmstrings[0]);

	XtSetArg(args[4], XmNshowAsDefault, 1);
	XtSetArg(args[5], XmNy, 200);
	XtSetArg(args[6], XmNx, 155);
	pushButton_1 = XtCreateManagedWidget("pushButton_1", xmPushButtonWidgetClass, drawingArea_1, args, 7);

	XtAddCallback(pushButton_1, XmNactivateCallback, done_callback, NULL);
 
	XmStringFree(xmstrings[0]);

	XmFontListFree(fontlist);

	XtSetArg(args[0], XmNalignment, XmALIGNMENT_BEGINNING);
	XtSetArg(args[1], XmNtraversalOn, False);
	XtSetArg(args[2], XmNmarginHeight, 10);
	XtSetArg(args[3], XmNmarginWidth, 10);
	XtSetArg(args[4], XmNrecomputeSize, True);
	XtSetArg(args[5], XmNforeground, get_pixel(parent, "black"));
	XtSetArg(args[6], XmNbackground, get_pixel(parent, "gray"));

	xmstrings[0] = make_note();

	XtSetArg(args[7], XmNlabelString, xmstrings[0]);
	fontlist = get_fontlist(parent, "-adobe-helvetica-medium-r-normal--14-140-75-75-p-77-iso8859-1");
	XtSetArg(args[8], XmNfontList, fontlist);
	label_4 = XtCreateManagedWidget("label_4", xmLabelWidgetClass, frame_2, args, 9);

	XmStringFree(xmstrings[0]);

	XmFontListFree(fontlist);

}
/**************************************************
* Function: make_about
**************************************************/
static XmString
make_note()
{
	XmString xms;
	XmString nxt;
	XmString lst;

	lst= XmStringCreateLtoR("lxb - Linux X/Motif Builder\n\n", XmSTRING_DEFAULT_CHARSET);
	nxt= XmStringCreateLtoR("lxb is an interactive graphical user interface builder.\n", XmSTRING_DEFAULT_CHARSET);
	xms = XmStringConcat(lst, nxt);
	XmStringFree(lst);
	XmStringFree(nxt);

	nxt = xms;
	lst = XmStringCreateLtoR("Further information about lxb and on how to use it\n", XmSTRING_DEFAULT_CHARSET);
	xms = XmStringConcat(xms, lst);
	XmStringFree(lst);
	XmStringFree(nxt);

	nxt = xms;
	lst = XmStringCreateLtoR("can be found at:\n", XmSTRING_DEFAULT_CHARSET);
	xms = XmStringConcat(xms, lst);
	XmStringFree(lst);
	XmStringFree(nxt);

	nxt = xms;
	lst = XmStringCreateLtoR("\n    http://www.umn.edu/nlhome/g257/parki005/lxb/lxb.html\n\n", XmSTRING_DEFAULT_CHARSET);
	xms = XmStringConcat(xms, lst);
	XmStringFree(lst);
	XmStringFree(nxt);

	nxt = xms;
	lst = XmStringCreateLtoR("e-mail: bruce.parkin-1@umn.edu", XmSTRING_DEFAULT_CHARSET);
	xms = XmStringConcat(xms, lst);
	XmStringFree(lst);
	XmStringFree(nxt);

	return(xms);
}
/*************************************************************
*
* Function: done_callback - pop down the About dialog
*
*************************************************************/
static void
done_callback(Widget w, XtPointer client_data, XtPointer call_data)   
{
	XtUnmanageChild(bb);
}
/*************************************************************
*
*	Function: popup_about_dialog
*
*		Show the "about lxb" dialog.
*
*************************************************************/
void
popup_about_dialog()
{
	if (!bb)
		build_about_gui(shell);

	XtManageChild(bb);
}

/********************************************************************************************
	Main part for Test of GUI component
*********************************************************************************************/

/*************************************************************
* Function: bail_callback - quit
*************************************************************/
static void
bail_callback(Widget w, XtPointer client_data, XtPointer call_data)   
{
	exit(0);
}
/*************************************************************
* Function: do_callback - do whatever
*************************************************************/
static void
do_callback(Widget w, XtPointer client_data, XtPointer call_data)   
{
	popup_about_dialog();
}
/**************************************************
* Function: build_main
**************************************************/
static void
build_main(Widget main)
{
	Widget drawingArea_4;
	Widget rowColumn_5;
	Widget pushButton_6;
	Widget pushButton_8;

	Arg args[100];
	XmString xmstrings[10];
	XmFontList fontlist;

	XtSetArg(args[0], XmNshadowThickness, 0);
	XtSetArg(args[1], XmNresizePolicy, XmRESIZE_NONE);
	XtSetArg(args[2], XmNwidth, 345);
	XtSetArg(args[3], XmNheight, 205);
	drawingArea_4 = XtCreateManagedWidget("drawingArea_4", xmDrawingAreaWidgetClass, main, args, 4);

	XtSetArg(args[0], XmNentryAlignment, XmALIGNMENT_CENTER);
	XtSetArg(args[1], XmNorientation, XmHORIZONTAL);
	XtSetArg(args[2], XmNpacking, XmPACK_COLUMN);
	XtSetArg(args[3], XmNnoResize, False);
	XtSetArg(args[4], XmNwidth, 171);
	XtSetArg(args[5], XmNheight, 52);
	XtSetArg(args[6], XmNy, 69);
	XtSetArg(args[7], XmNx, 67);
	rowColumn_5 = XtCreateManagedWidget("rowColumn_5", xmRowColumnWidgetClass, drawingArea_4, args, 8);

	xmstrings[0] = XmStringCreateSimple("Do It!");
	XtSetArg(args[0], XmNlabelString, xmstrings[0]);
	fontlist = get_fontlist(main, "-adobe-helvetica-bold-r-normal--18-180-75-75-p-103-iso8859-1");
	XtSetArg(args[1], XmNfontList, fontlist);
	XtSetArg(args[2], XmNy, 3);
	XtSetArg(args[3], XmNx, 3);
	pushButton_6 = XtCreateManagedWidget("pushButton_6", xmPushButtonWidgetClass, rowColumn_5, args, 4);

	XtAddCallback(pushButton_6, XmNactivateCallback, do_callback, NULL);

	XmStringFree(xmstrings[0]);
	XmFontListFree(fontlist);

	XtSetArg(args[0], XmNshowAsDefault, 1);
	xmstrings[0] = XmStringCreateSimple("Bail Out!");
	XtSetArg(args[1], XmNlabelString, xmstrings[0]);
	fontlist = get_fontlist(main, "-adobe-helvetica-bold-r-normal--18-180-75-75-p-103-iso8859-1");
	XtSetArg(args[2], XmNfontList, fontlist);
	XtSetArg(args[3], XmNy, 3);
	XtSetArg(args[4], XmNx, 98);
	pushButton_8 = XtCreateManagedWidget("pushButton_8", xmPushButtonWidgetClass, rowColumn_5, args, 5);

	XtAddCallback(pushButton_8, XmNactivateCallback, bail_callback, NULL);

	XmStringFree(xmstrings[0]);
	XmFontListFree(fontlist);

}
/**************************************************
* Function: main
**************************************************/
int 
main(int argc, char *argv[])
{
	Arg args[10];
	int n;
	Widget w;
	Widget pb;

	/* Initialize toolkit and parse command line options. */
	shell = XtInitialize(NULL, "testshell", NULL, 0, &argc, argv);

	XtSetArg(args[0], XmNx, 385);
	XtSetArg(args[1], XmNy, 440);
	XtSetValues(shell, args, 2);

	build_main(shell);

	XtRealizeWidget(shell);
	XtMainLoop();
}
