/**************************************************
* File: wtree.c - application source file
*
*    This file is generated by the program lxb.
*
**************************************************/

/* include files */
#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/Frame.h>
#include <Xm/DrawingA.h>
#include "Tree.h"
#include "Panner.h"
#include "Porthole.h"

#include "wtree.h"

/* global variables */
Widget tree;

static void
PortholeCallback(Widget w, XtPointer panner_ptr, XtPointer report_ptr);

static void
PannerCallback(Widget w, XtPointer closure, XtPointer report_ptr);

/**************************************************
* Function: build_wtree_area
**************************************************/
void
build_wtree_area(Widget tst)
{
	Widget dis;
	Widget drawingArea_4;
	Widget frame_6;
	Widget drawingArea_7;
	Widget drawingArea_9;

	Arg args[100];
	XmString xmstrings[10];
	XmFontList fontlist;

	Widget porthole;
	Widget button;
	Widget button3;
	Widget panner;
	Widget da;

	XtSetArg(args[0], XmNbackground, get_pixel(tst, "gray"));
	drawingArea_4 = XtCreateManagedWidget("drawingArea_4", xmDrawingAreaWidgetClass, tst, args, 1);

	XtSetArg(args[0], XmNy, 0);
	XtSetArg(args[1], XmNx, 0);
	XtSetArg(args[2], XmNbackground, get_pixel(tst, "gray"));
	frame_6 = XtCreateManagedWidget("frame_6", xmFrameWidgetClass, drawingArea_4, args, 3);

	XtSetArg(args[0], XtNheight, 50);
	XtSetArg(args[1], XtNwidth, 50);
	XtSetArg(args[2], XtNresize, False);
	panner = XtCreateManagedWidget("panner", pannerWidgetClass, frame_6, args, 3);

	/* the parent of the tree tstplay */
	XtSetArg(args[0], XtNy, 100);
	XtSetArg(args[1], XtNwidth, 200);
	XtSetArg(args[2], XtNheight, 200);
	porthole = XtCreateManagedWidget("porthole", portholeWidgetClass, drawingArea_4, args, 3);

	tree = XtCreateManagedWidget("tree", treeWidgetClass, porthole, args, 0);

	button = XtCreateManagedWidget("button1", xmPushButtonWidgetClass, tree, args, 0);

	XtSetArg(args[0], XtNtreeParent, button);
	button = XtCreateManagedWidget("button2", xmPushButtonWidgetClass, tree, args, 1);

	XtSetArg(args[0], XtNtreeParent, button);
	button3 = XtCreateManagedWidget("button3", xmPushButtonWidgetClass, tree, args, 1);

	XtSetArg(args[0], XtNtreeParent, button3);
	button = XtCreateManagedWidget("button4", xmPushButtonWidgetClass, tree, args, 1);
	XtSetArg(args[0], XtNtreeParent, button3);
	button = XtCreateManagedWidget("button5", xmPushButtonWidgetClass, tree, args, 1);
	XtSetArg(args[0], XtNtreeParent, button3);
	button = XtCreateManagedWidget("button6", xmPushButtonWidgetClass, tree, args, 1);

    XtAddCallback(porthole, XtNreportCallback, PortholeCallback, (XtPointer) panner);
    XtAddCallback(panner, XtNreportCallback, PannerCallback, (XtPointer) porthole);
}
/**********************************************************************
*
*  Function Name: PortholeCallback
*
*  Description: called when the porthole or its child has changed
*
*  Arguments: porthole - the porthole widget.
*             panner_ptr - the panner widget.
*             report_ptr - the porthole record.
*
*  Returns: none.
*
**********************************************************************/
static void
PortholeCallback(Widget w, XtPointer panner_ptr, XtPointer report_ptr)
{
    Arg args[10];
    Cardinal n = 0;
    XawPannerReport *report = (XawPannerReport *) report_ptr;
    Widget panner = (Widget) panner_ptr;
 
    XtSetArg (args[n], XtNsliderX, report->slider_x); n++;
    XtSetArg (args[n], XtNsliderY, report->slider_y); n++;
    if (report->changed != (XawPRSliderX | XawPRSliderY)) {
			XtSetArg (args[n], XtNsliderWidth, report->slider_width); n++;
			XtSetArg (args[n], XtNsliderHeight, report->slider_height); n++;
			XtSetArg (args[n], XtNcanvasWidth, report->canvas_width); n++;
			XtSetArg (args[n], XtNcanvasHeight, report->canvas_height); n++;
    };

    XtSetValues (panner, args, n);
}
/**********************************************************************
*
*  Function Name: PannerCallback
*
*  Description: called when the panner has moved.
*
*  Arguments: panner - the panner widget.
*             closure - *** NOT USED ***.
*             report_ptr - the panner record.
*
*  Returns: none.
*
**********************************************************************/
static void
PannerCallback(Widget w, XtPointer closure, XtPointer report_ptr)
{
    Arg args[2];
    XawPannerReport *report = (XawPannerReport *) report_ptr;
 
    XtSetArg (args[0], XtNx, -report->slider_x);
    XtSetArg (args[1], XtNy, -report->slider_y);
 
    XtSetValues(tree, args, 2);
}
