/*********************************************************************
 *
 *	xenum.h
 *
 ********************************************************************/

/* data struct definition */
typedef struct _oneenum{
  char *name;
  int  number;
}ENUMUNIT;

typedef struct _allenums{
  int index;
  int count;
  ENUMUNIT unit[10];
}ENUMSTRUCT, *ENUMLIST;      

/*--------------------------------------*/

static ENUMSTRUCT enum_unit[] = {
{	/* unitType */
0,
5,
	"XmPIXELS",  0,
	"Xm100TH_MILLIMETERS", 1,
	"Xm1000TH_INCHES", 2,
	"Xm100TH_POINTS", 3,
	"Xm100TH_FONT_UNITS", 4,
},

{	/* navigationType */
1,
4,
	"XmNONE", 0, 
	"XmTAB_GROUP",	1, 
	"XmSTICKY_TAB_GROUP",	2, 
	"XmEXCLUSIVE_TAB_GROUP",	3,
},

{	/* row column, menus */
2,
3,
	"XmNO_ORIENTATION",	0,
	"XmVERTICAL",	1,
	"XmHORIZONTAL",	2,
},

{	/*	packing in row column */
3,
4,
	"XmNO_PACKING",	0,
	"XmPACK_TIGHT",	1,
	"XmPACK_COLUMN",	2,
	"XmPACK_NONE",		3,
},

{	/* label and string align */
4,
3,
	"XmALIGNMENT_BEGINNING",	0,
	"XmALIGNMENT_CENTER",	1,
	"XmALIGNMENT_END",	2,
},

/* toggle button - indicatorType*/
{
5,
2,
	"XmN_OF_MANY",	1,
	"XmONE_OF_MANY", 2,
},

/* form child constraints */
{
6,
7,
	"XmATTACH_NONE",	0,
	"XmATTACH_FORM",	1,
	"XmATTACH_OPPOSITE_FORM",	2,
	"XmATTACH_WIDGET",	3,
	"XmATTACH_OPPOSITE_WIDGET",	4,
	"XmATTACH_POSITION",	5,
	"XmATTACH_SELF",	6,
},

/* resizePolicy */
{
7,
3,
	"XmRESIZE_NONE", 0,
	"XmRESIZE_GROW", 1, 
	"XmRESIZE_ANY",	2,
},

{	/* shadowType*/
8,
4,
	"XmSHADOW_ETCHED_IN",	5, 
	"XmSHADOW_ETCHED_OUT",	6, 
	"XmSHADOW_IN",	7,
	"XmSHADOW_OUT", 8,
},


{	/* separator */
9,
10,
	"XmNO_LINE",	0,
	"XmSINGLE_LINE",	1, 
	"XmDOUBLE_LINE",	2, 
	"XmSINGLE_DASHED_LINE",	3,
	"XmDOUBLE_DASHED_LINE",	4, 
	"XmSHADOW_ETCHED_IN",		5, 
	"XmSHADOW_ETCHED_OUT",	6, 
	"XmSHADOW_ETCHED_IN_DASH",	7, 
	"XmSHADOW_ETCHED_OUT_DASH",	8,	 
	"XmINVALID_SEPARATOR_TYPE",	9,
},

{ /* labelType */
10,
2,
	"XmPIXMAP",	1,
	"XmSTRING",	2,
},

{
11,
4,
	"XmARROW_UP",	0,
	"XmARROW_DOWN",	1,
	"XmARROW_LEFT",	2,
	"XARROW_RIGHT",	3,
},

{
12,
2,
	"False",	0,
	"True",	1,
},

{
13,
5,
	"XmWORK_AREA", 0,
	"XmMENU_BAR", 1,
	"XmMENU_PULLDOWN", 2,
  "XmMENU_POPUP", 3,
	"XmMENU_OPTION", 4,
},

{
14,
2,
	"XmAUTOMATIC", 0,
	"XmAPPLICATION_DEFINED", 1,
},

{
15,
2,
	"XmMULTI_LINE_EDIT", 0,
	"XmSINGLE_LINE_EDIT", 1,
},

{
16,
2,
	"XmSTATIC", 0,
	"XmAS_NEEDED", 1,
},

{
17,
4,
	"XmMAX_ON_TOP", 0,
	"XmMAX_ON_BOTTOM", 1,
	"XmMAX_ON_LEFT", 2,
	"XmMAX_ON_RIGHT", 3,
},

{
18,
3,
	"XmVARIABLE", 0,
	"XmCONSTANT", 1,
	"XmRESIZE_IF_POSSIBLE", 2,
},

/*************/

};
