#
# File: Makefile.linux
#
#		Makefile used to make lxb for the Linux O/S
#
#---------------------------------------------------------------------------

CC=gcc

CDEBUGFLAGS = -g -pipe -m486 
CDEBUGFLAGS = -g -pipe

INCLUDES = -I../include -I/usr/contrib/X11R6/include
DEFINES =
CFLAGS = $(CDEBUGFLAGS) $(INCLUDES) $(DEFINES)

LDFLAGS = -o
XLIBS = -lSM -lICE -L/usr/X11R6/lib -L/usr/lib/Motif1.2_R6 -lXm -L/opt/xpm/lib/X11 -lXpm -L/usr/contrib/X11R6/lib -lXaw -lXmu  -lXt  -lXext -lX11
LIBS = $(XLIBS)

#---------------------------------------------------------------------------
OBJS = about.o cascade.o cfunctions.o children.o cmenu.o \
	code.o code_gui.o code_hdr.o code_special.o code_util.o  code_xdefs.o \
	color.o create_composite.o create_simple.o cscrolled.o cvt_resvalue.o \
	data.o delete.o diag.o dialogs.o dump.o end_program.o fonts.o forms.o \
	get_resnames.o get_resvalue.o id_resource.o instant.o lxb.o menu.o \
	menubar.o menushell.o mhandlers.o misc.o open.o play.o populate.o 	\
	pulldown.o recreate.o recres.o save.o select.o selected.o set_resvalue.o \
	show_options.o show_res.o special.o top.o translations.o util.o \
	ResourceEd.o Wtree.o TextObject.o Pallet.o TopShell.o CallbackEd.o callbacks.o
#---------------------------------------------------------------------------

lxb: $(OBJS) 
	$(CC) $(LDFLAGS) lxb $(OBJS) $(LIBS) 

relink:
	rm -f lxb
	$(CC) $(LDFLAGS) lxb $(OBJS) $(LIBS)

all: clean ctags depend lxb

clean:
	rm -f lxb *.o *.bak *.a 

ctags:	
	ctags -S *.c
