/**********************************************************************
*
* File: about.c - application source file
*
*		This file is generated by the program lxb.
*		(Well, the first original version).
*		
*		This puts up a popup dialog with information about
*		the program lxb when the About button is pressed in
*		the Help pulldown menu from the menubar.
*		
*    Copyright (C) 1995  Bruce Parkin
*
*********************************************************************/

/* include files */
#include <stdio.h>

#include <Xm/Xm.h>
#include <Xm/MwmUtil.h> 
#include <Xm/PushB.h>
#include <Xm/BulletinB.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/DrawingA.h>

#include "lxb.h"
#include "fonts.h"
#include "color.h"
#include "about.h"


/* local variables */
static Widget bb = NULL;

/* local prototypes */
static XmString 
make_about_xmstring();

static void
build_about_gui(Widget parent);
static void
done_callback(Widget w, XtPointer client_data, XtPointer call_data);       

/*************************************************************
*
*	Function: popup_about_dialog
*
*		Show the "about lxb" dialog.
*
*************************************************************/
void
popup_about_dialog()
{
	if (!bb)
		build_about_gui(shell);

	XtManageChild(bb);
}
/*************************************************************
*
* Function: done_callback - pop down the About dialog
*
*************************************************************/
static void
done_callback(Widget w, XtPointer client_data, XtPointer call_data)   
{
	XtUnmanageChild(bb);
}
/**********************************************************************
*
* Function: build_about_gui - build the GUI for 
*		a popup dialog that tells about "lxb"
*
*		The advantage to using the XmCreate*Dialog functions
*		over Xt ones is that the Popup Dialog is auto-centered over
*		parent widget.
*
**********************************************************************/
static void
build_about_gui(Widget parent)
{
	Widget drawingArea_1;
	Widget frame_2;
	Widget pushButton_1;
	Widget label_4;
	Arg args[10];
	XmString xmstrings[10];
	XmFontList fontlist;
	int n;

  n=0;
  XtSetArg(args[n], XmNtitle, "About lxb");n++;
  XtSetArg(args[n], XmNdeleteResponse, XmDO_NOTHING);n++;
  XtSetArg(args[n], XmNmwmFunctions,
                    MWM_FUNC_RESIZE|MWM_FUNC_MOVE|MWM_FUNC_MINIMIZE|MWM_FUNC_MAXIMIZE);n++;  

	XtSetArg(args[n], XmNbackground, get_pixel("gray"));n++;
	bb = XmCreateBulletinBoardDialog(parent, "about_dialog", args, n);

	XtSetArg(args[0], XmNbackground, get_pixel("gray"));
	drawingArea_1 = XtCreateManagedWidget("drawingArea_1", xmDrawingAreaWidgetClass, bb, args, 1);

	XtSetArg(args[0], XmNshadowThickness, 5);
	XtSetArg(args[1], XmNshadowType, XmSHADOW_OUT);
	frame_2 = XtCreateManagedWidget("frame_2", xmFrameWidgetClass, drawingArea_1, args, 2);

	XtSetArg(args[0], XmNforeground, get_pixel("black"));
	XtSetArg(args[1], XmNbackground, get_pixel("gray"));

	fontlist = get_fontlist(parent, "-adobe-helvetica-bold-r-normal--14-140-75-75-p-82-iso8859-1");
	XtSetArg(args[2], XmNfontList, fontlist);

	xmstrings[0] = XmStringCreateSimple("Done");
	XtSetArg(args[3], XmNlabelString, xmstrings[0]);

	XtSetArg(args[4], XmNshowAsDefault, 1);
	XtSetArg(args[5], XmNy, 200);
	XtSetArg(args[6], XmNx, 155);
	pushButton_1 = XtCreateManagedWidget("pushButton_1", xmPushButtonWidgetClass, drawingArea_1, args, 7);

	XtAddCallback(pushButton_1, XmNactivateCallback, done_callback, NULL);
 
	XmStringFree(xmstrings[0]);

	XmFontListFree(fontlist);

	XtSetArg(args[0], XmNalignment, XmALIGNMENT_BEGINNING);
	XtSetArg(args[1], XmNtraversalOn, False);
	XtSetArg(args[2], XmNmarginHeight, 10);
	XtSetArg(args[3], XmNmarginWidth, 10);
	XtSetArg(args[4], XmNrecomputeSize, True);
	XtSetArg(args[5], XmNforeground, get_pixel("black"));
	XtSetArg(args[6], XmNbackground, get_pixel("gray"));

	/* make the displayed text */
	xmstrings[0] = make_about_xmstring();

	XtSetArg(args[7], XmNlabelString, xmstrings[0]);
	fontlist = get_fontlist(parent, "-adobe-helvetica-medium-r-normal--14-140-75-75-p-77-iso8859-1");
	XtSetArg(args[8], XmNfontList, fontlist);
	label_4 = XtCreateManagedWidget("label_4", xmLabelWidgetClass, frame_2, args, 9);

	XmStringFree(xmstrings[0]);

	XmFontListFree(fontlist);

}
/**************************************************
* Function: make_about
*
*		This puts together the XmString text for display
*		on the "About" dialog
8
**************************************************/
static XmString
make_about_xmstring()
{
	XmString xms;
	XmString nxt;
	XmString lst;

	lst= XmStringCreateLtoR("lxb - Linux X/Motif Builder\n\n", XmSTRING_DEFAULT_CHARSET);
	nxt= XmStringCreateLtoR("lxb is an interactive graphical user interface builder.\n", XmSTRING_DEFAULT_CHARSET);
	xms = XmStringConcat(lst, nxt);
	XmStringFree(lst);
	XmStringFree(nxt);

	nxt = xms;
	lst = XmStringCreateLtoR("Further information about lxb and on how to use it\n", XmSTRING_DEFAULT_CHARSET);
	xms = XmStringConcat(xms, lst);
	XmStringFree(lst);
	XmStringFree(nxt);

	nxt = xms;
	lst = XmStringCreateLtoR("can be found at:\n", XmSTRING_DEFAULT_CHARSET);
	xms = XmStringConcat(xms, lst);
	XmStringFree(lst);
	XmStringFree(nxt);

	nxt = xms;
	lst = XmStringCreateLtoR("\n    http://www.umn.edu/nlhome/g257/parki005/lxb/lxb.html\n\n", XmSTRING_DEFAULT_CHARSET);
	xms = XmStringConcat(xms, lst);
	XmStringFree(lst);
	XmStringFree(nxt);

	nxt = xms;
	lst = XmStringCreateLtoR("e-mail: bruce.parkin-1@umn.edu", XmSTRING_DEFAULT_CHARSET);
	xms = XmStringConcat(xms, lst);
	XmStringFree(lst);
	XmStringFree(nxt);

	return(xms);
}
