/**************************************************
*
* File: code_xdefs.c
*
*    Copyright (C) 1997  Bruce Parkin 
*
**************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>    
/*
#include <ctype.h>    
*/

#ifdef SOLARIS24
#include <string.h>    
#else
#include <strings.h>    
#endif

#include <Xm/Xm.h>
#include "lxb.h"
#include "code_xdefs.h"
#include "code.h"

/**************************************************
 *
 * Function: make_appdefs
 *
 **************************************************/
int
make_appdefs(char *appname)
{
	int 	status;
	FILE	*file;
	char 	geometry[50];
	char 	file_name[50];
	Arg		args[10];
	char	tmp[10];
	Position	x,y;
	Dimension	wi, he;

	strcpy(file_name, appname);
	strcat(file_name, "-ad");

	/* don't overwrite the old file */
	status = check_file(file_name);
	if (status != OK)
		return (NOTOK);

	/* create the appdefs file*/
  file = fopen(file_name, "w");
  if (file == NULL){
    perror("problem with App-ad file");
    return (NOTOK);
  };

	/* general/default app defs */
	fprintf(file, "!---------------------------------------------------\n");
	fprintf(file, "! File: Application defaults for ");
	fprintf(file, "%s\n", appname);
  fprintf(file, "!\n");
  fprintf(file, "!    This file is generated by the program lxb.\n");
  fprintf(file, "!\n");  
	fprintf(file, "!---------------------------------------------------\n\n");
/*
	fprintf(file, "%s*menubar*fontList:	-*-helvetica-bold-o-normal-*-14-*-iso8859-1\n", appname);
	fprintf(file, "%s*icon*fontList: -adobe-times-bold-r-normal-*-12-*-*-*-*-*-iso8859-1\n", appname);
	fprintf(file, "%s*Background: gray75\n", appname);
*/

	/* app shell */

/*
	XtSetArg(args[0], XmNwidth, &wi);
	XtSetArg(args[1], XmNheight, &he);
	XtSetArg(args[2], XmNx, &x);
	XtSetArg(args[3], XmNy, &y);
	XtGetValues(appShell, args, 4);

	sprintf(tmp, "%u", wi);
	strcpy(geometry, tmp);
	strcat(geometry, "x");
	sprintf(tmp, "%u", he);
	strcat(geometry, tmp);
	strcat(geometry, "+");
	sprintf(tmp, "%u", x);
	strcat(geometry, tmp);
	strcat(geometry, "+");
	sprintf(tmp, "%u", y);
	strcat(geometry, tmp);
	fprintf(file, "%s.geometry: %s\n", appname, geometry);
	fprintf(file, "%s.iconName: %s\n", appname, appname);
	fprintf(file, "%s.title: %s\n", appname, appname);

*/

	fclose(file);

	return(OK);
}
